function Editor() {
  
  this.ON = false;
  
  this.loadMap = "empty";
  
  
  this.placeStartExit = 0;
  
  
  this.start = function() {
    game.map.load(this.loadMap);
    
    window.setInterval(function() {
      game.editor.loop();
    }, 33);
    
    mouse.registerUpArea("edit", 0, 0, game.width, game.height, function() {
      game.editor.edit();
    });
    
    jQuery("body").append("<form><textarea id=\"map_editor_output\" style=\"width: 500px; height: 300px;\"></textarea></form>");
  };
  
  
  this.edit = function() {
    
    if(mouse.isOver(0, 0, 132, 60) || mouse.isOver(662, 0, 108, 60) || mouse.isOver(0, 412, 124, 68)) {
      return;
    }
    var tilePos = game.map.getTileCoords(mouse.x, mouse.y);
    var tileOffset = game.map.getTileOffset(mouse.x, mouse.y);
    
    if(this.placeStartExit == 0) { 
      this.placeStartExit = 1;
      game.map.tiles[tilePos.y][tilePos.x] = 18;
      
    } else if(this.placeStartExit == 1) {
      this.placeStartExit = 2;
      game.map.tiles[tilePos.y][tilePos.x] = 19;

    } else {
      if(tileOffset.x >= 8 && tileOffset.x < 40 && tileOffset.y < 8) {
        this.addOpening("top", tilePos.x, tilePos.y);
        this.addOpening("bottom", tilePos.x, tilePos.y - 1);
        
      } else if(tileOffset.y >= 8 && tileOffset.y < 40 && tileOffset.x >= 40) {
        this.addOpening("right", tilePos.x, tilePos.y);
        this.addOpening("left", tilePos.x + 1, tilePos.y);
        
      } else if(tileOffset.x >= 8 && tileOffset.x < 40 && tileOffset.y >= 40) {
        this.addOpening("bottom", tilePos.x, tilePos.y);
        this.addOpening("top", tilePos.x, tilePos.y + 1);
        
      } else if(tileOffset.y >= 8 && tileOffset.y < 40 && tileOffset.x < 8) {
        this.addOpening("left", tilePos.x, tilePos.y);
        this.addOpening("right", tilePos.x - 1, tilePos.y);
        
      }
    }
    
    this.echoMap();
    
  };
  
  
  this.addOpening = function(side, x, y) {
    var tileType = game.map.getTileType(x, y);
    if(tileType != 18 && tileType != 19) {
      var collision = game.map.getCollisionSides(tileType);
      var col = { top: collision.top, right: collision.right, bottom: collision.bottom, left: collision.left };
      var newTile = 32;
      col[side] = 0;
      
      if(col.top == 1 && col.right == 0 && col.bottom == 1 && col.left == 0) {
        newTile = Math.floor(Math.random() * 2);
        
      } else if(col.top == 0 && col.right == 1 && col.bottom == 0 && col.left == 1) {
        newTile = 2 + Math.floor(Math.random() * 2);
        
      } else if(col.top == 0 && col.right == 1 && col.bottom == 1 && col.left == 0) {
        newTile = 4;
        
      } else if(col.top == 0 && col.right == 0 && col.bottom == 1 && col.left == 1) {
        newTile = 5;
        
      } else if(col.top == 1 && col.right == 0 && col.bottom == 0 && col.left == 1) {
        newTile = 6;
        
      } else if(col.top == 1 && col.right == 1 && col.bottom == 0 && col.left == 0) {
        newTile = 7;
        
      } else if(col.top == 1 && col.right == 0 && col.bottom == 0 && col.left == 0) {
        newTile = 8;
        
      } else if(col.top == 0 && col.right == 1 && col.bottom == 0 && col.left == 0) {
        newTile = 9;
        
      } else if(col.top == 0 && col.right == 0 && col.bottom == 1 && col.left == 0) {
        newTile = 10;
        
      } else if(col.top == 0 && col.right == 0 && col.bottom == 0 && col.left == 1) {
        newTile = 11;
        
      } else if(col.top == 1 && col.right == 1 && col.bottom == 1 && col.left == 0) {
        newTile = 12;
        
      } else if(col.top == 0 && col.right == 1 && col.bottom == 1 && col.left == 1) {
        newTile = 13;
        
      } else if(col.top == 1 && col.right == 0 && col.bottom == 1 && col.left == 1) {
        newTile = 14;
        
      } else if(col.top == 1 && col.right == 1 && col.bottom == 0 && col.left == 1) {
        newTile = 15;
        
      } else if(col.top == 0 && col.right == 0 && col.bottom == 0 && col.left == 0) {
        newTile = 16;
        
      }
      
      game.map.tiles[y][x] = newTile;
      
    }
  };
  
  
  this.echoMap = function() {
    
    var string = "";
    
    for(var y = 0; y < 10; y++) {
      string += "   ";
      
      for(var x = 0; x < 16; x++) {
        
        var tile = game.map.tiles[y][x];
        for(var code in game.map.codes) {
          if(game.map.codes[code] == tile) {
            string += " " + code;
          }
        }
      }
      
      string += "\n";
    }
    jQuery("#map_editor_output").html(string);
  };
  
  
  this.loop = function() {
    
    c.drawImage(img.get("mapBG"), 0, 0);
    
    game.map.draw();
    
    c.drawImage(img.get("editor"), 0, 0);
    
    c.drawImage(img.get("counter"), 664, 4);
    
    game.map.drawTimer();
    
    game.drawAudioButton();
    
    game.map.drawResetButton();
    
  };
}