function Game() {
  
  this.firstMap = "map_0";
  this.lastMap = "map_12";
  
  
  this.width = 768;
  
  this.height = 480;
  
  this.map;
  
  this.lighting;
  
  this.milton;
  
  this.editor;
  
  this.torchCounterText;
  
  this.torchCounterTorch;
  
  this.torchCounter = 50;
  
  this.audioOn = true;
  
  this.startGameButton;
  this.creditsButton;
  
  this.onMenu = false;
  
  this.gameInterval;
  
  
  this.init = function() {
    c.fillStyle = "#000";
    c.fillRect(0, 0, this.width, this.height);
    
    img.loadLoadingScreen();
    
    keyboard.init();
    
    this.map = new Map();
    this.map.init();
    
    this.milton = new Milton();
    
    this.editor = new Editor();
  };
  
  
  this.showLoadingScreen = function() {
    c.fillStyle = "#099";
    c.fillRect(0, 0, this.width, this.height);
    
    c.drawImage(img.loadingScreenImage, 0, 0);
  };
  
  
  this.hideLoadingScreen = function() {
    if(this.editor.ON) {
      this.editor.start();
    } else {
      this.showMenu();
    }    
  };
  
  
  this.showMenu = function() {
    
    this.onMenu = true;
    
    this.startGameButton = new Button();
    this.startGameButton.position(256, 280);
    this.startGameButton.setLabel("Start game");
    this.startGameButton.blue();
    this.startGameButton.registerCallback("startGameButton", function() {
      game.startGameButton.deleteCallback("startGameButton");
      game.creditsButton.deleteCallback("creditsButton");
      game.onMenu = false;
      game.showGame();
    });
    
    this.creditsButton = new Button();
    this.creditsButton.position(256, 360);
    this.creditsButton.setLabel("Credits");
    this.creditsButton.registerCallback("creditsButton", function() {
      game.startGameButton.deleteCallback("startGameButton");
      game.creditsButton.deleteCallback("creditsButton");
      game.map.alertBox("Created by Henry Raymond\nfor Ludum Dare 26", "Close");
      game.map.alertBoxButton.registerCallback("alertBoxButton", function() {
        game.map.alertBoxButton.deleteCallback("alertBoxButton");
        game.map.hideAlertBox();
        game.showMenu();
      });
    });
    
    this.menuLoop();
    
  };
  
  
  this.menuLoop = function() {
    
    if(!this.onMenu) {
      return;
    }
    
    c.fillStyle = "#000";
    c.fillRect(0, 0, this.width, this.height);
    
    c.drawImage(img.get("menuBG"), 0, 0);
    c.drawImage(img.get("logo"), 0, 40);
    
    this.startGameButton.draw();
    this.creditsButton.draw();
    
    this.map.drawAlertBox();
    
    //this.drawAudioButton();
    
    window.setTimeout(function() {
      game.menuLoop();
    }, 33);
    
  };
  
  
  this.showGame = function() {
    
    this.torchCounter = 50;
    
    c.fillStyle = "#000";
    c.fillRect(0, 0, this.width, this.height);
    
    this.lighting = new Lighting();
    this.lighting.init();
    
    /*mouse.registerUpArea("audio", 8, 420, 52, 52, function() {
      game.audioOn = !game.audioOn;
    });*/
    
    this.showMap(this.firstMap);
  };
  
  
  this.showMap = function(mapName) {
    
    this.map.load(mapName);
    
    this.torchCounterText = new Text();
    
    this.torchCounterTorch = new Torch();
    this.torchCounterTorch.position(688, 36);
    
    this.map.start();
    
    this.gameInterval = window.setInterval(function() {
      game.loop();
    }, 33);
    
  };
  
  
  this.loop = function() {
    if(this.onMenu) {
      return;
    }
    
    this.map.update();
    this.milton.update();
    
    c.drawImage(img.get("mapBG"), 0, 0);
    
    this.map.draw();
    
    this.lighting.drawTorches(false);
    
    this.milton.draw();
    
    this.lighting.drawTorches(true);
    
    this.lighting.draw();
    
    c.drawImage(img.get("counter"), 664, 4);
    
    if(game.torchCounter > 9) {
      this.torchCounterText.position(708, 16);
    } else {
      this.torchCounterText.position(728, 16);
    }
    this.torchCounterText.text(game.torchCounter.toString());
    this.torchCounterText.draw();
    
    this.torchCounterTorch.draw();
    
    this.map.drawTimer();
    
    this.map.drawMessages();
    
    this.map.drawStartRunningButton();
    
    this.map.drawAlertBox();
    
    //this.drawAudioButton();
    
    this.map.drawResetButton();
    
  };
  
  
  this.drawAudioButton = function() {
    var sx = 180;
    if(!this.audioOn) {
      sx += 180;
    }
    if(mouse.isOver(8, 420, 52, 52)) {
      sx += 60;
      if(mouse.down) {
        sx += 60;
      }
    }
    c.drawImage(img.get("resetAudio"), sx, 0, 60, 64, 4, 416, 60, 64);
  };
  
  
  
}