function Lighting() {
  
  this.width;
  this.height;
  
  this.lightingCanvas;
  this.lightingContext;
  
  this.TORCH_CONE_WIDTH = 36;
  this.TORCH_CONE_HEIGHT = 36;
  
  this.torchConeData = [];
  
  this.torches = {};
  
  this.torchesCounter = 0;
  
  this.alpha = 0.0;
  
  this.dim = false;
  
  
  this.init = function() {
    
    this.width = game.width / 4;
    this.height = game.height / 4;
    
    this.lightingCanvas = document.createElement("canvas");
    this.lightingCanvas.width = this.width;
    this.lightingCanvas.height = this.height;
    
    this.lightingContext = this.lightingCanvas.getContext("2d");
    
    var torchConeCanvas = document.createElement("canvas");
    torchConeCanvas.width = this.TORCH_CONE_WIDTH;
    torchConeCanvas.height = this.TORCH_CONE_HEIGHT;
    
    var torchConeContext = torchConeCanvas.getContext("2d");
    torchConeContext.fillStyle = "#fff";
    torchConeContext.fillRect(0, 0, this.TORCH_CONE_WIDTH, this.TORCH_CONE_HEIGHT);
    torchConeContext.drawImage(img.get("lighting"), 0, 0);
    
    var torchConeContextData = torchConeContext.getImageData(0, 0, this.TORCH_CONE_WIDTH, this.TORCH_CONE_HEIGHT);
    for(var i = 0; i < (this.TORCH_CONE_WIDTH * this.TORCH_CONE_HEIGHT); i++) {
      this.torchConeData[i] = (255 - torchConeContextData.data[i * 4]) / 255;
    }
  };
  
  
  this.drawTorches = function(inFrontOfMilton) {
    for(var torchId in this.torches) {
      this.torches[torchId].draw(inFrontOfMilton);
    }
  };
  
  
  this.draw = function() {
    
    if(this.dim && this.alpha < 1.0) {
      this.alpha += 0.02;
    }
      
    if(this.alpha == 0.0) {
      return;
    }
    
    this.lightingContext.fillStyle = "#fff";
    this.lightingContext.fillRect(0, 0, this.width, this.height);
    
    this.lightingContext.drawImage(img.get("exitLight"), (game.map.endX * 12) - 12, (game.map.endY * 12) - 2);
    this.lightingContext.drawImage(img.get("startLight"), (game.map.startX * 12), (game.map.startY * 12) - 2);
    
    var lightingData = this.lightingContext.getImageData(0, 0, this.width, this.height);
    var px = lightingData.data;
    
    for(var i = 0; i < px.length; i += 4) {
      px[i + 3] = px[i + 0];
      px[i + 0] = 0;
      px[i + 1] = 0;
      px[i + 2] = 0;
    }
    
    for(var torchId in this.torches) {
      var torch = this.torches[torchId];
      
      var rand = 0.8 + 0.2 * Math.random();
      var startX = Math.round((torch.x / 4) - (this.TORCH_CONE_WIDTH / 2));
      var startY = Math.round((torch.y / 4) - (this.TORCH_CONE_HEIGHT / 2));
      var i;
      var coneI = 0;
      for(var x = startX; x < startX + this.TORCH_CONE_WIDTH; x++) {
        for(var y = startY; y < startY + this.TORCH_CONE_HEIGHT; y++) {
          i = ((y * this.width) + x) * 4;
          px[i + 3] = (255 - Math.round(255 * this.torchConeData[coneI] * rand)) - (255 - px[i + 3]);
          coneI++;
        }
      }
    }
    
    this.lightingContext.putImageData(lightingData, 0, 0);
    c.globalAlpha = this.alpha;
    c.drawImage(this.lightingCanvas, 0, 0, game.width, game.height);
    c.globalAlpha = 1;
    
    
  };
  
  
  this.addTorch = function() {
    if(game.map.phase != 0 || game.map.showAlertBox) {
      return;
    }
    if(mouse.isOver(0, 0, 132, 60) || mouse.isOver(662, 0, 108, 60) || mouse.isOver(0, 412, 124, 68) || mouse.isOver(640, 420, 128, 60)) {
      return;
    }
    for(var torchId in this.torches) {
      var torchX = this.torches[torchId].x;
      var torchY = this.torches[torchId].y;
      if(mouse.x >= torchX - 8 && mouse.x < torchX + 12 && mouse.y >= torchY - 8 && mouse.y <= torchY + 12) {
        return;
      }
    }
    if(game.torchCounter <= 0) {
      return;
    }
    game.torchCounter--;
    this.torchesCounter++;
    game.map.torchesPlacedOnThisMap++;
    this.torches[this.torchesCounter] = new Torch();
    this.torches[this.torchesCounter].position(mouse.x, mouse.y);
  };
  
  
  this.deleteAllTorches = function() {
    for(var torchId in this.torches) {
      var torch = this.torches[torchId];
      for(var particleId in torch.particles) {
        delete torch.particles[particleId];
      }
      delete this.torches[torchId];
    }
  };
  
  
  
}