function Map() {
  
  this.tiles = [[]];
  
  this.codes = {
    "-" : 0,
    "=" : 1,
    "I" : 2,
    "l" : 3,
    "J" : 4,
    "L" : 5,
    "F" : 6,
    "?" : 7,
    "V" : 8,
    "(" : 9,
    "A" : 10,
    ")" : 11,
    "}" : 12,
    "W" : 13,
    "{" : 14,
    "M" : 15,
    "+" : 16,
    "@" : 18,
    "#" : 19,
    "." : 32,
  };
  
  this.collision = {
    0  : {top: 1, right: 0, bottom: 1, left: 0},
    1  : {top: 1, right: 0, bottom: 1, left: 0},
    2  : {top: 0, right: 1, bottom: 0, left: 1},
    3  : {top: 0, right: 1, bottom: 0, left: 1},
    4  : {top: 0, right: 1, bottom: 1, left: 0},
    5  : {top: 0, right: 0, bottom: 1, left: 1},
    6  : {top: 1, right: 0, bottom: 0, left: 1},
    7  : {top: 1, right: 1, bottom: 0, left: 0},
    8  : {top: 1, right: 0, bottom: 0, left: 0},
    9  : {top: 0, right: 1, bottom: 0, left: 0},
    10 : {top: 0, right: 0, bottom: 1, left: 0},
    11 : {top: 0, right: 0, bottom: 0, left: 1},
    12 : {top: 1, right: 1, bottom: 1, left: 0},
    13 : {top: 0, right: 1, bottom: 1, left: 1},
    14 : {top: 1, right: 0, bottom: 1, left: 1},
    15 : {top: 1, right: 1, bottom: 0, left: 1},
    16 : {top: 0, right: 0, bottom: 0, left: 0},
    18 : {top: 1, right: 0, bottom: 1, left: 1},
    19 : {top: 1, right: 1, bottom: 1, left: 0},
    32 : {top: 1, right: 1, bottom: 1, left: 1},
  };
  
  this.startX = 0;
  this.startY = 0;
  
  this.endX = 0;
  this.endY = 0;
  
  this.name;
  this.title;
  this.nextMap;
  
  this.phase = 0;
  
  this.torchesPlacedOnThisMap = 0;
  
  this.placementTime = 0;
  this.runningTime = 0;
  
  this.placementTimer = 0;
  this.runningTimer = 0;
  
  this.timerText;
  
  this.showPlacementMessage = false;
  this.placementMessageAlpha;
  
  this.showRunningMessage = false;
  this.runningMessageAlpha;
  
  this.showAlertBox = false;
  this.alertBoxLine1;
  this.alertBoxLine2;
  this.alertBoxButton;
  this.showAlertBoxMilton = false;
  
  this.showStartRunningButton;
  this.startRunningButton;
  
  
  this.init = function() {
    this.timerText = new Text();
    this.alertBoxLine1 = new Text();
    this.alertBoxLine2 = new Text();
    this.alertBoxButton = new Button();
    this.alertBoxButton.position(256, 280);
    
    this.startRunningButton = new Button();
    this.startRunningButton.position(644, 424);
    this.startRunningButton.setLabel("Run >      ..");
  };
  
  
  this.load = function(name) {
    
    this.name = name;
    
    this.placementTime = parseInt(jQuery("#" + this.name + " .placement_time").html(), 10);
    this.runningTime = parseInt(jQuery("#" + this.name + " .running_time").html(), 10);
    this.title = jQuery("#" + this.name + " .title").html().replace("//", "\n");
    this.nextMap = jQuery("#" + this.name + " .next_map").html();
    
    var input = jQuery("#" + name + " .tiles").html();
    var line = 0;
    var tile = 0;
    this.tiles = [[]];
    for(var i = 0; i < input.length; i++) {
      var c = input[i];
      if(c == "@") {
        this.startX = tile;
        this.startY = line;
      }
      if(c == "#") {
        this.endX = tile;
        this.endY = line;
      }
      if(c == " ") {
        continue;
      } else if(c == "\n") {
        if(this.tiles[line].length > 0) {
          line++;
          tile = 0;
          this.tiles[line] = [];
        }
      } else if(this.codes.hasOwnProperty(c)) {
        this.tiles[line][tile] = this.codes[c];
        tile++;
      } else {
        this.tiles[line][tile] = 31;
        tile++;
      }
    }
    
    this.torchesPlacedOnThisMap = 0;

  };
  
  
  this.loadNextMap = function() {
    this.load(this.nextMap);
    this.start();
  };
  
  
  this.start = function() {
    
    this.phase = 0;
    
    this.placementTimer = this.placementTime;
    this.runningTimer = this.runningTime;
    
    this.placementMessageAlpha = 1.0;
    this.runningMessageAlpha = 1.0;
    
    game.lighting.alpha = 0.0;
    game.lighting.dim = false;
    
    game.lighting.deleteAllTorches();
    
    game.torchCounter += this.torchesPlacedOnThisMap;
    this.torchesPlacedOnThisMap = 0;
    
    game.milton.positionOnStart();
    
    mouse.registerUpArea("addTorch", 0, 0, game.width, game.height, function() {
      game.lighting.addTorch();
    });
    
    mouse.registerUpArea("resetLevel", 8, 420, 52, 52, function() {
      game.map.start();
    });
    if(game.map.name != game.firstMap) {
      this.alertBox(this.title, "Play level");
      this.alertBoxButton.registerCallback("alertBoxButton", function() {
        game.map.alertBoxButton.deleteCallback("alertBoxButton");
        game.map.hideAlertBox();
        game.map.placeStartRunningButton();
      });
   
    } else {
      this.showAlertBoxMilton = true;
      this.alertBox("Meet Milton.", "Continue");
      this.alertBoxButton.registerCallback("alertBoxButton", function() {
        game.map.showAlertBoxMilton = false;
        game.map.alertBox("Milton went on an\nadventure.", "Continue");
        game.map.alertBoxButton.registerCallback("alertBoxButton", function() {
          game.map.alertBox("But he got lost.\nAnd it's getting dark.", "Continue");
          game.map.alertBoxButton.registerCallback("alertBoxButton", function() {
            game.map.alertBox("As a minimalist, he only\n brought 50 torches.", "Continue");
            game.map.alertBoxButton.registerCallback("alertBoxButton", function() {
              game.map.alertBox("Place them, so that\nMilton can find his way.", "Continue");
              game.map.alertBoxButton.registerCallback("alertBoxButton", function() {
                game.map.alertBox("Be quick.\nYou don't have much time.", "OK");
                game.map.alertBoxButton.registerCallback("alertBoxButton", function() {
                  game.map.alertBoxButton.deleteCallback("alertBoxButton");
                  game.map.hideAlertBox();
                  game.map.placeStartRunningButton();
                });
              });
            });
          });
        });
      });
    }
  };
  
  
  this.placeStartRunningButton = function() {
    
    game.map.showStartRunningButton = true;
    game.map.startRunningButton.registerCallback("startRunning", function() {
      
      game.map.startRunningButton.deleteCallback("startRunning");
      game.map.showStartRunningButton = false;
      game.map.placementTimer = 0;
      game.map.phase = 1;
      game.lighting.dim = true;
    });
  };
  
  
  this.update = function() {
    if(this.showAlertBox) {
      return;
    }
    this.showPlacementMessage = false;
    this.showRunningMessage = false;
    if(this.phase == 0) {
      this.placementTimer -= 0.033;
      if(this.placementTimer <= 0) {
        this.startRunningButton.deleteCallback("startRunning");
        this.showStartRunningButton = false;
        this.placementTimer = 0;
        this.phase = 1;
        game.lighting.dim = true;
      }
      if(this.placementTimer > this.placementTime - 2.5) {
        this.showPlacementMessage = true;
        if(this.placementTimer < this.placementTime - 2) {
          this.placementMessageAlpha -= 0.066;
        }
      }
    } else {
      this.runningTimer -= 0.033;
      if(this.runningTimer <= 0) {
        this.runningTimer = 0;
        this.alertBox("The time ran out.\nPoor Milton.", "Try again");
        this.alertBoxButton.registerCallback("alertBoxButton", function() {
          game.map.alertBoxButton.deleteCallback("alertBoxButton");
          game.map.hideAlertBox();
          game.map.start();
        });
      }
      if(this.runningTimer > this.runningTime - 2.5) {
        this.showRunningMessage = true;
        if(this.runningTimer < this.runningTime - 2) {
          this.runningMessageAlpha -= 0.066;
        }
      }
    }
    
  };
  
  
  this.draw = function() {
    for(var y = 0; y < 10; y++) {
      for(var x = 0; x < 16; x++) {
        var tile = this.tiles[y][x];
        if(tile != 32) {
          var sx = (tile % 8) * 48;
          var sy = Math.floor(tile / 8) * 48;
          var sw = 48;
          var sh = 48;
          c.drawImage(img.get("tiles"), sx, sy, sw, sh, x * 48, y * 48, 48, 48);
        }
      }
    }
  };
  
  
  this.drawTimer = function() {
    
    var timer;
    if(this.phase == 0) {
      timer = this.placementTimer;
    } else {
      timer = this.runningTimer;
    }
    
    var timerString = Math.floor(timer / 60.0).toString() + ":";
    var seconds = Math.floor(timer) % 60;
    if(seconds > 9) {
      timerString += seconds.toString();
    } else {
      timerString += "0" + seconds.toString();
    }
    var decaSeconds = Math.floor(timer * 10) % 10;
    timerString += "." + decaSeconds.toString();
    
    c.drawImage(img.get("timer"), 4, 4);
    
    this.timerText.position(16, 16);
    this.timerText.text(timerString);
    this.timerText.draw();
  };
  
  
  this.drawMessages = function() {
    if(this.showPlacementMessage) {
      c.globalAlpha = this.placementMessageAlpha;
      c.drawImage(img.get("placeYourTorches"), 0, 0);
      c.globalAlpha = 1;
    }
    if(this.showRunningMessage) {
      c.globalAlpha = this.runningMessageAlpha;
      c.drawImage(img.get("runToTheExit"), 0, 0);
      c.globalAlpha = 1;
    }
  };
  
  
  this.getTileCoords = function(x, y) {
    return { x : Math.floor(x / 48), y : Math.floor(y / 48) };
  };
  
  
  this.getTileType = function(x, y) {
    if(x < 0 || x >= 16 || y < 0 || y >= 10) {
      return 32;
    }
    return this.tiles[y][x];
  };
  
  
  this.getCollisionSides = function(tileType) {
    return this.collision[tileType];
  };
  
  
  this.getTileOffset = function(x, y) {
    return { x : x % 48, y : y % 48 };
  };
  
  
  this.drawResetButton = function() {
    var sx = 0;
    if(mouse.isOver(8, 420, 52, 52)) {
      sx += 60;
      if(mouse.down) {
        sx += 60;
      }
    }
    c.drawImage(img.get("resetAudio"), sx, 0, 64, 64, 4, 416, 60, 64);
  };
  
  
  this.alertBox = function(text, buttonLabel) {
    this.showAlertBox = true;
    var lines = text.split("\n");
    
    if(lines.length >= 1) {
      this.alertBoxLine1.position(384, 156);
      this.alertBoxLine1.text(lines[0]);
      this.alertBoxLine1.center();
    } else {
      this.alertBoxLine1.text("");
    }
    if(lines.length >= 2) {
      this.alertBoxLine2.position(384, 204);
      this.alertBoxLine2.text(lines[1]);
      this.alertBoxLine2.center();
    } else {
      this.alertBoxLine2.text("");
    }
    
    this.alertBoxButton.setLabel(buttonLabel);
  };
  
  
  this.hideAlertBox = function() {
    this.showAlertBox = false;
  };
  
  
  this.drawAlertBox = function() {
    if(this.showAlertBox) {
      
      c.drawImage(img.get("alertBox"), 0, 0);
      this.alertBoxLine1.draw();
      this.alertBoxLine2.draw();
      this.alertBoxButton.draw();
      if(this.showAlertBoxMilton) {
        c.drawImage(img.get("milton"), 144, 0, 48, 48, 360, 204, 48, 48);
      };
    }
  };
  
  
  this.drawStartRunningButton = function() {
    if(this.showStartRunningButton) {
      this.startRunningButton.draw();
    }
  };
 
  
}