function Milton() {
  
  this.COLLISION_DISTANCE = 12;
  
  this.x = 0;
  
  this.y = 0;
  
  this.direction = 0;
  
  this.animationStep = 0;
  
  this.isWalking = false;
  
  this.startAnimation = 12;
  
  
  this.position = function(x, y) {
    this.x = x;
    this.y = y;
  };
  
  
  this.positionOnTile = function(x, y) {
    this.x = (x * 48) + 24;
    this.y = (y * 48) + 32;
  };
  
  
  this.positionOnStart = function() {
    this.positionOnTile(game.map.startX - 1, game.map.startY);
    this.startAnimation = 12;
  };
  
  
  this.update = function() {
    
    var oldX = this.x;
    var oldY = this.y;
    
    if(this.startAnimation > 0 && !game.map.showAlertBox) {
      this.direction = 0;
      this.startAnimation--;
      this.x += 4;
    }
    
    if(game.map.phase == 1 && !game.map.showAlertBox) {       

      if(keyboard.isPressed(keyboard.ARROW_LEFT)) {
        this.x -= 4;
        this.direction = 1;
      }
      if(keyboard.isPressed(keyboard.ARROW_RIGHT)) {
        this.x += 4;
        this.direction = 0;
      }
      if(keyboard.isPressed(keyboard.ARROW_UP)) {
        this.y -= 4;
      }
      if(keyboard.isPressed(keyboard.ARROW_DOWN)) {
        this.y += 4;
      }
      
      var tileCoords = game.map.getTileCoords(this.x, this.y);
      var tileType = game.map.getTileType(tileCoords.x, tileCoords.y);
      var collisionSides = game.map.getCollisionSides(tileType);
      
      var tileOffset = game.map.getTileOffset(this.x, this.y);
      
      if(collisionSides.top == 1 && tileOffset.y < this.COLLISION_DISTANCE) {
        this.y += 4;
      }
      if(collisionSides.right == 1 && tileOffset.x > 48 - this.COLLISION_DISTANCE) {
        this.x -= 4;
      }
      if(collisionSides.bottom == 1 && tileOffset.y > 48 - this.COLLISION_DISTANCE) {
        this.y -= 4;
      }
      if(collisionSides.left == 1 && tileOffset.x < this.COLLISION_DISTANCE) {
        this.x += 4;
      }
      if(collisionSides.top == 0 && collisionSides.left == 0 && tileOffset.x < this.COLLISION_DISTANCE && tileOffset.y < this.COLLISION_DISTANCE) {
        this.x += 4;
        this.y += 4;
      }
      if(collisionSides.right == 0 && collisionSides.top == 0 && tileOffset.x > 48 - this.COLLISION_DISTANCE && tileOffset.y < this.COLLISION_DISTANCE) {
        this.x -= 4;
        this.y += 4;
      }
      if(collisionSides.bottom == 0 && collisionSides.right == 0 && tileOffset.x > 48 - this.COLLISION_DISTANCE && tileOffset.y > 48 - this.COLLISION_DISTANCE) {
        this.x -= 4;
        this.y -= 4;
      }
      if(collisionSides.left == 0 && collisionSides.bottom == 0 && tileOffset.x < this.COLLISION_DISTANCE && tileOffset.y > 48 - this.COLLISION_DISTANCE) {
        this.x += 4;
        this.y -= 4;
      }
      
      if(tileType == 19 && tileOffset.x > 24) {
        if(game.map.name == game.lastMap) {
          game.map.alertBox("Congratulations!\nYou led Milton to safety.", "Main menu");
          game.map.alertBoxButton.registerCallback("alertBoxButton", function() {
            game.map.alertBoxButton.deleteCallback("alertBoxButton");
            mouse.deleteUpArea("addTorch");
            mouse.deleteUpArea("resetLevel");
            game.map.hideAlertBox();
            window.clearInterval(game.gameInterval);
            game.showMenu();
          });
        } else {
          game.map.loadNextMap();
        }
      }
    }
    
    if(oldX != this.x || oldY != this.y) {
      this.isWalking = true;
    } else {
      this.isWalking = false;
    }
    
    if(this.isWalking) {
      this.animationStep++;
      if(this.animationStep >= 16) {
        this.animationStep = 0;
      }
    } else {
      this.animationStep = 3;
    }
    
  };
  
  
  this.draw = function() {
    var sx = this.animationStep * 48;
    var sy = this.direction * 48;
    var sw = 48;
    var sh = 48;
    
    c.drawImage(img.get("milton"), sx, sy, sw, sh, this.x - 24, this.y - 40, 48, 48);
  };
  
  
}